import randomGenerator from './RandomGenerator'
import { Country } from '../../Enum/Country'
import { Gender } from '../../Enum/Gender'

export class PersonalIdGenerator {
  /**
   * return e.generate = function (e, t) {
    var
      n = this.getYearPart(),
      r = this.getMonthPart(),
      i = this.getDayPart(),
      o = this.getIdNumPart(),
      a = this.getGenderPart(e, t),
      l = this.getControlSum(e, n, r, i, o, a);
    return "pl" === e ? n + r + i + o + a + l : a + n + r + i + o + l
  },
   * @param country
   * @param gender
   */
  generate (country: Country, gender: Gender) {
    console.log(country, gender)
    const n = this.getYearPart()
    const r = this.getMonthPart()
    const i = this.getDayPart()
    const o = this.getIdNumPart()
    const a = this.getGenderPart(country, gender)
    console.log(country, gender, a)
    const l = this.getControlSum(country, n, r, i, o, a)

    return Country.POLAND === country ? n + r + i + o + a + l : a + n + r + i + o + l
  }

  /**
   * e.getYearPart = function () {
    var e = (new Date).getFullYear();
    return String(Iu.generate(e - 25, e - 55)).substring(2, 4)
  },
   */
  getYearPart () {
    const e = (new Date()).getFullYear()
    return String(randomGenerator.generate(e - 25, e - 55)).substring(2, 4)
  }

  /**
   *  e.getMonthPart = function () {
    return Iu.generate(1, 12).toString().padStart(2, "0")
  },
   */
  getMonthPart () {
    return randomGenerator.generate(1, 12).toString().padStart(2, '0')
  }

  /**
   *  e.getDayPart = function () {
    return Iu.generate(1, 28).toString().padStart(2, "0")
  },
   */
  getDayPart () {
    return randomGenerator.generate(1, 28).toString().padStart(2, '0')
  }

  /**
   * e.getIdNumPart = function () {
    return Iu.generate(1, 999).toString().padStart(3, "0")
  },
   */
  getIdNumPart () {
    return randomGenerator.generate(1, 999).toString().padStart(3, '0')
  }

  /**
   *  e.getGenderPart = function (e, t) {
    switch (e) {
      case"pl":
        "male" === t ? t = String(2 * Iu.generate(1, 5) - 1) : "female" === t && (t = String(2 * Iu.generate(1, 4)));
        break;
      default:
        "male" === t ? t = "3" : "female" === t && (t = "4")
    }
    return t
  },
   * @param country
   * @param gender
   */
  getGenderPart (country: Country, gender: Gender) {
    console.log(country, gender)
    switch (country) {
      case Country.POLAND:
        console.log(country)
        return Gender.MALE === gender
          ? String(2 * randomGenerator.generate(1, 5) - 1)
          : String(2 * randomGenerator.generate(1, 4))
      default:
        console.log(gender, Gender.MALE === gender)
        return Gender.MALE === gender ? '3' : '4'
    }
  }

  /**
   * e.getControlSum = function (e, t, n, r, i, o) {
    var a, l;
    if ("pl" === e) return l = +(a = t + n + r + i + o)[0] + 3 * +a[1] + 7 * +a[2] + 9 * +a[3] + +a[4] + 3 * +a[5] + 7 * +a[6] + 9 * +a[7] + +a[8] + 3 * +a[9], 0 != (l %= 10) && (l = 10 - l), String(l);
    a = o + t + n + r + i;
    for (var s = 1, u = 3, c = 0, d = 0, h = 0; h < 10; h++) {
      var p = +a[h];
      c += p * s, d += p * u, 10 == ++s && (s = 1), 10 == ++u && (u = 1)
    }
    return d %= 11, (c %= 11) < 10 ? String(c) : d < 10 ? String(d) : String(0)
  }
   * @param e
   * @param t
   * @param n
   * @param r
   * @param i
   * @param o
   */
  getControlSum (e: Country, t: string, n: string, r: string, i: string, o: string) {
    let a
    let l
    if (Country.POLAND === e) {
      l = +(a = t + n + r + i + o)[0] + 3 * +a[1] + 7 * +a[2] + 9 * +a[3] + +a[4] + 3 * +a[5] + 7 * +a[6] + 9 * +a[7] + +a[8] + 3 * +a[9];
      (l %= 10) !== 0 && (l = 10 - l)
      l = String(l)

      return l
    }

    let c = 0
    let d = 0
    a = o + t + n + r + i
    for (let s = 1, u = 3, c = 0, d = 0, h = 0; h < 10; h++) {
      const p = +a[h]
      c += p * s
      d += p * u
      ++s === 10 && (s = 1)
      ++u === 10 && (u = 1)
    }
    d %= 11
    return (c %= 11) < 10 ? String(c) : d < 10 ? String(d) : String(0)
  }
}

export default new PersonalIdGenerator()
